-- Name: sbf_ss.lua
-- 名称: 飞系声声词显示优化
-- Version: 20231109
-- Author: 戴石麟
local function sbf_ss(input, env, seg)
    local schema = env.engine.schema
    local enabled = schema.schema_id == "sbfd" or schema.schema_id == "sbfm" or schema.schema_id == "sbfx" 
    local i = 1
    for cand in input:iter() do
        if enabled and string.len(cand.preedit) == 2 then
            local first = string.sub(cand.preedit, 1, 1)
			local second = string.sub(cand.preedit, 2, -1)
            if string.find("qwrtsdfgzxcvbyphjklnm", first) and string.find("qwrtsdfgzxcvbyphjklnm", second) and i == 1 then
				local fake_text = code2word(cand.preedit)
				if cand.text ~= fake_text then
					cand:get_genuine().comment = " " .. fake_text
				end
			end
        end
	    i = i + 1
        yield(cand)
    end
end

function code2word(code)
    local vjc = {"并不","不错","不断","办法","罢工","保护","北京","不肯","本来","罢免","半年","被迫","表情","必然","表示","半天","备案","把握","必须","不要","不住","出版","常常","程度","充分","成功","窗户","参加","此刻","处理","充满","才能","产品","采取","承认","此时","传统","长安","从未","出现","产业","存在","代表","调查","得到","地方","大哥","电话","多久","打开","带来","多么","多年","大批","地区","敌人","但是","点头","第二","单位","东西","第一","弟子","发表","非常","反对","方法","法国","发挥","房间","放开","法律","父母","妇女","分配","父亲","妇人","发生","发帖","反而","服务","发现","反应","发展","根本","工程","感到","功夫","改革","规划","国际","赶快","管理","革命","姑娘","股票","感情","果然","告诉","共同","关爱","各位","关系","关于","工作","毫不","何处","活动","恢复","回归","缓缓","环境","很快","后来","后面","河南","害怕","好奇","忽然","和尚","会谈","黑暗","毫无","或许","会议","孩子","基本","基础","觉得","解放","结果","几乎","经济","加快","建立","急忙","今年","金牌","加强","进入","建设","今天","骄傲","极为","进行","教育","记者","恐怖","考察","看到","开放","客观","客户","科技","可靠","考虑","昆明","可能","恐怕","口气","客人","开始","客厅","可爱","渴望","科学","可以","控制","老板","露出","领导","浪费","两国","厉害","立即","离开","理论","连忙","理念","老婆","离去","老人","历史","老头","两岸","另外","冷笑","领域","老者","目标","名称","目的","麻烦","美国","模糊","面积","模块","美丽","慢慢","美女","门派","目前","美人","马上","眉头","名额","美味","模型","美元","名字","宁波","农村","难道","能否","能够","女孩","年纪","难看","努力","你们","男女","哪怕","年轻","女人","那时","念头","女儿","那位","那些","那样","女子","旁边","平常","判断","佩服","屁股","破坏","平静","片刻","漂亮","拼命","陪你","偏偏","脾气","仆人","平时","普通","配偶","颇为","培训","朋友","批准","确保","清楚","取得","气氛","奇怪","前后","期间","情况","强烈","签名","青年","强迫","轻轻","情人","其实","其他","请按","千万","情形","企业","其中","日本","人才","认得","乳房","如果","如何","如今","认可","人类","人们","热闹","软盘","热情","仍然","认识","认同","热爱","认为","热线","人员","认真","身边","市场","似的","十分","送给","时候","时间","时刻","顺利","什么","少女","水平","事情","虽然","身上","身体","是啊","所谓","实现","所以","身子","特别","提出","听到","突发","通过","谈话","条件","痛苦","讨论","他们","头脑","谈判","提起","突然","同时","太太","图案","台湾","体系","统一","同志","耳边","暗藏","耳朵","案犯","爱国","而后","案件","安康","案例","澳门","儿女","安排","爱情","爱人","昂首","儿童","偶尔","安危","恶心","而已","按照","无比","完成","问道","无法","无关","文化","文件","网卡","网络","我们","无奈","无派","完全","温柔","完善","问题","我爱","微微","微笑","唯一","位置","宣布","形成","许多","幸福","香港","喜欢","小姐","胸口","训练","项目","性能","芯片","心情","显然","先生","系统","喜爱","希望","相信","需要","现在","一般","因此","一定","衣服","应该","以后","已经","一块","原来","以免","云南","一旁","一切","依然","于是","摇头","因而","因为","一些","一样","一直","准备","支持","知道","政府","这个","之后","自己","召开","这里","怎么","只能","只怕","之前","众人","只是","总统","这儿","作为","这些","这样","组织"}
	local n1 = code2num(string.sub(code,1,1))
	local n2 = code2num(string.sub(code,2,-1))
	local n12 = n1 * 21 + n2 + 1
	
	return vjc[n12]
end

function code2num(code)
	local num = string.byte(code,1)
	if (num > string.byte('u')) then 
		return num - 97 - 5
	elseif (num > string.byte('o')) then
		return num - 97 - 4
	elseif (num > string.byte('i')) then
		return num - 97 - 3
	elseif (num > string.byte('e')) then
		return num - 97 - 2
	elseif (num > string.byte('a')) then
		return num - 97 - 1
	else
		return num - 97
	end
end

return sbf_ss
